/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     CLASS = 258,
     DOCUMENTATION = 259,
     IDENT = 260,
     MACRONAME = 261,
     TEMPLATE = 262,
     PATH = 263,
     DISABLE = 264,
     LCURLYBK = 265,
     RCURLYBK = 266,
     LSQBK = 267,
     RSQBK = 268,
     LPAREN = 269,
     RPAREN = 270,
     INHERIT = 271,
     FATHERREL = 272,
     MINUS = 273,
     PLUS = 274,
     XPLUS = 275,
     STAR = 276,
     NEG = 277,
     PREC = 278,
     ANCESTOR = 279,
     COMMA = 280,
     COLON = 281,
     SEMICOLON = 282,
     DOUBLECOLON = 283,
     EQUAL = 284,
     XEQUAL = 285,
     DOT = 286,
     ALT = 287,
     JOIN = 288,
     BANG = 289,
     IMP = 290,
     EQUIV = 291,
     DESC = 292,
     NODE = 293,
     OPT = 294,
     VALUE = 295,
     VAR = 296,
     FATHER = 297
   };
#endif
/* Tokens.  */
#define CLASS 258
#define DOCUMENTATION 259
#define IDENT 260
#define MACRONAME 261
#define TEMPLATE 262
#define PATH 263
#define DISABLE 264
#define LCURLYBK 265
#define RCURLYBK 266
#define LSQBK 267
#define RSQBK 268
#define LPAREN 269
#define RPAREN 270
#define INHERIT 271
#define FATHERREL 272
#define MINUS 273
#define PLUS 274
#define XPLUS 275
#define STAR 276
#define NEG 277
#define PREC 278
#define ANCESTOR 279
#define COMMA 280
#define COLON 281
#define SEMICOLON 282
#define DOUBLECOLON 283
#define EQUAL 284
#define XEQUAL 285
#define DOT 286
#define ALT 287
#define JOIN 288
#define BANG 289
#define IMP 290
#define EQUIV 291
#define DESC 292
#define NODE 293
#define OPT 294
#define VALUE 295
#define VAR 296
#define FATHER 297




/* Copy the first part of user declarations.  */
#line 1 "parser.y"

#include <stdio.h>
#define YYSTYPE char*
extern int yylex();
extern unsigned yylineno;

#include "libxml/tree.h"
extern xmlDocPtr document_xml ;
extern xmlNodePtr MetaGrammar ;
extern xmlNodePtr CurrentClass ;
extern int class_found ;
extern int error_symb ;
extern int keep_comments;

#include "hash.h"
#include "symbol.h"

//#define DEBUGYACC 0
#ifdef DEBUGYACC
#define DBUGYACC(x) x
#else
#define DBUGYACC(x)
#endif

#define MALLOCERROR(xxxx) {printf("malloc_error:\t%s (line number: %d)\n",xxxx,yylineno);exit(-1);}

char * cp_str (char * str1, char * str2) {
  char * new_str ;
  if (str1 == NULL) return (str2) ;
  if (str2 == NULL) return (str1) ;
  new_str = (char*) calloc(strlen(str1)+strlen(str2)+1,sizeof (char)) ;
  sprintf (new_str, "%s%s", str1, str2) ;
  free (str1); free(str2) ;
  return (new_str) ;
}

unsigned char * xmlstrdup (unsigned char * in) {
    unsigned char *out;
    int ret,size,out_size,temp;
    xmlCharEncodingHandlerPtr handler;
    
    size = (int)strlen(in)+1; 
    out_size = size*2-1; 
    out = malloc((size_t)out_size); 

    if (out) {
        handler = xmlFindCharEncodingHandler("iso-8859-1") ;
        if (!handler) {
            free (out);
            out = NULL;
	    printf ("xmlstrdup: no handler\n") ; exit (1) ;
        }
    }
    if (out) {
      temp=size-1;
      ret = handler->input(out, &out_size, in, &temp);
      if ((ret < 0) || (temp-size+1)) {
	if (ret < 0) {
	  printf ("xmlstrdup: conversion wasn't successful.\n");
	}
	else {
	  printf ("xmlstrdup: conversion wasn't successful. converted: %i octets.\n", temp);
	}
	free (out);
	out = NULL;
	exit (1) ;
      }
      else {
	out = realloc(out,out_size+1); 
	out[out_size]=0; /*null terminating out*/
      }
    }
    else {
      MALLOCERROR ("xmlstrdup") ;
    }
    return (out);
}
 
 


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 271 "parser.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  9
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   173

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  43
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  41
/* YYNRULES -- Number of rules.  */
#define YYNRULES  91
/* YYNRULES -- Number of states.  */
#define YYNSTATES  170

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   297

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     8,    11,    13,    14,    15,    16,
      28,    29,    36,    37,    44,    48,    51,    52,    55,    60,
      63,    65,    67,    69,    71,    73,    75,    77,    79,    81,
      83,    85,    87,    90,    94,    98,   102,   106,   113,   114,
     116,   120,   124,   128,   133,   137,   141,   143,   147,   149,
     153,   155,   159,   163,   167,   170,   174,   177,   182,   185,
     187,   191,   193,   195,   197,   199,   201,   205,   207,   210,
     212,   216,   218,   222,   229,   231,   234,   236,   239,   243,
     244,   248,   252,   254,   259,   264,   266,   269,   272,   274,
     278,   279
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      44,     0,    -1,    45,    83,    -1,    46,    -1,    45,    46,
      -1,     1,    -1,    -1,    -1,    -1,    83,     3,     5,    47,
      83,    48,    10,    83,    49,    52,    11,    -1,    -1,    83,
       7,     6,    50,    29,    74,    -1,    -1,    83,     8,     6,
      51,    29,    78,    -1,    83,     9,     5,    -1,     1,    11,
      -1,    -1,    53,    83,    -1,    53,    27,    83,    52,    -1,
       1,    27,    -1,    54,    -1,    55,    -1,    56,    -1,    57,
      -1,    58,    -1,    59,    -1,    68,    -1,    75,    -1,    80,
      -1,    81,    -1,    62,    -1,    67,    -1,    16,     5,    -1,
      82,    17,    82,    -1,    82,    24,    82,    -1,    82,    23,
      82,    -1,    82,    29,    82,    -1,    37,    14,    12,    60,
      13,    15,    -1,    -1,    61,    -1,    60,    25,    61,    -1,
       5,    26,    74,    -1,    82,    35,    63,    -1,    22,    82,
      35,    63,    -1,    82,    19,    63,    -1,    82,    20,    63,
      -1,    64,    -1,    63,    32,    64,    -1,    66,    -1,    65,
      25,    66,    -1,    66,    -1,    65,    25,    66,    -1,    69,
      29,    69,    -1,    69,    30,    69,    -1,    34,    69,    -1,
      69,    29,    69,    -1,    79,    78,    -1,    40,    14,    74,
      15,    -1,    41,    82,    -1,    72,    -1,    72,    32,    71,
      -1,     5,    -1,    21,    -1,    19,    -1,    18,    -1,    72,
      -1,    72,    32,    71,    -1,    73,    -1,    22,    73,    -1,
      70,    -1,    70,    33,    74,    -1,     6,    -1,    12,    60,
      13,    -1,    14,     5,    15,    12,    60,    13,    -1,    76,
      -1,    39,    76,    -1,    77,    -1,    38,    77,    -1,    82,
      26,    74,    -1,    -1,    31,     5,    78,    -1,    31,     6,
      78,    -1,    37,    -1,    42,    14,    82,    15,    -1,    38,
      14,    82,    15,    -1,    70,    -1,    18,    82,    -1,    19,
      82,    -1,     5,    -1,    82,    28,     5,    -1,    -1,     4,
      83,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,    93,    93,   102,   105,   106,   109,   121,   129,   108,
     142,   141,   158,   157,   173,   184,   186,   187,   198,   209,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   224,   233,   243,   253,   263,   273,   285,   290,
     298,   307,   317,   326,   335,   348,   363,   370,   377,   378,
     385,   391,   399,   407,   418,   426,   438,   445,   453,   460,
     466,   474,   480,   486,   490,   495,   496,   504,   505,   511,
     515,   521,   527,   531,   538,   539,   546,   552,   559,   571,
     575,   584,   595,   600,   606,   612,   615,   623,   631,   635,
     645,   646
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "CLASS", "DOCUMENTATION", "IDENT",
  "MACRONAME", "TEMPLATE", "PATH", "DISABLE", "LCURLYBK", "RCURLYBK",
  "LSQBK", "RSQBK", "LPAREN", "RPAREN", "INHERIT", "FATHERREL", "MINUS",
  "PLUS", "XPLUS", "STAR", "NEG", "PREC", "ANCESTOR", "COMMA", "COLON",
  "SEMICOLON", "DOUBLECOLON", "EQUAL", "XEQUAL", "DOT", "ALT", "JOIN",
  "BANG", "IMP", "EQUIV", "DESC", "NODE", "OPT", "VALUE", "VAR", "FATHER",
  "$accept", "Axiom", "Dcllist", "Dcl", "@1", "@2", "@3", "@4", "@5",
  "Proplist", "Property", "Heritage", "Pere", "Ancetre", "Precedence",
  "Equality", "Desc", "Features", "F", "Guard", "EqAlt", "EqSeq", "EqSeq1",
  "EqElem", "Atomic", "Equation", "EqTerm", "Varname", "AtomAlts", "Atom",
  "NValue", "Value", "Node", "VNode", "RawNode", "Path", "RootOfPath",
  "Needs", "Provides", "Idname", "Doc", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    43,    44,    45,    45,    45,    47,    48,    49,    46,
      50,    46,    51,    46,    46,    46,    52,    52,    52,    52,
      53,    53,    53,    53,    53,    53,    53,    53,    53,    53,
      53,    53,    54,    55,    56,    57,    58,    59,    60,    60,
      60,    61,    62,    62,    62,    62,    63,    63,    64,    64,
      65,    65,    66,    66,    67,    68,    69,    69,    70,    71,
      71,    72,    72,    72,    72,    73,    73,    74,    74,    74,
      74,    74,    74,    74,    75,    75,    76,    76,    77,    78,
      78,    78,    79,    79,    79,    79,    80,    81,    82,    82,
      83,    83
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     1,     2,     1,     0,     0,     0,    11,
       0,     6,     0,     6,     3,     2,     0,     2,     4,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     3,     3,     3,     3,     6,     0,     1,
       3,     3,     3,     4,     3,     3,     1,     3,     1,     3,
       1,     3,     3,     3,     2,     3,     2,     4,     2,     1,
       3,     1,     1,     1,     1,     1,     3,     1,     2,     1,
       3,     1,     3,     6,     1,     2,     1,     2,     3,     0,
       3,     3,     1,     4,     4,     1,     2,     2,     1,     3,
       0,     2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     5,    90,     0,     0,     3,     0,    15,    91,     1,
       0,     4,     2,     0,     0,     0,     0,     6,    10,    12,
      14,    90,     0,     0,     7,     0,    79,     0,    61,    71,
      38,     0,    64,    63,    62,     0,     0,    69,    65,    67,
      11,     0,    13,    90,     0,     0,    39,     0,    68,    88,
      58,     0,     0,    79,    79,     8,     0,    72,     0,     0,
       0,    70,    66,    59,    80,    81,     0,    41,    40,    38,
      89,     0,     0,     0,     0,     0,     0,     0,    82,     0,
       0,     0,     0,     0,    90,    20,    21,    22,    23,    24,
      25,    30,    31,    26,     0,    85,    27,    74,    76,    79,
      28,    29,     0,     0,    60,    19,    32,    86,    87,     0,
      82,     0,    54,     0,     0,    77,     0,     0,    75,     0,
       0,     9,    90,    17,     0,    56,     0,     0,     0,     0,
       0,     0,     0,     0,    73,     0,    38,     0,     0,     0,
       0,    55,    33,    44,    46,     0,    48,     0,    45,    35,
      34,    78,    36,    42,    43,     0,    84,    57,    83,    18,
       0,     0,     0,     0,     0,    47,    49,    52,    53,    37
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     3,     4,     5,    21,    27,    66,    22,    23,    83,
      84,    85,    86,    87,    88,    89,    90,    45,    46,    91,
     143,   144,   145,   146,    92,    93,   147,    95,    62,    38,
      39,    40,    96,    97,    98,    42,    99,   100,   101,   116,
       6
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -76
static const yytype_int16 yypact[] =
{
     131,    15,    11,    64,    59,   -76,   138,   -76,   -76,   -76,
      15,   -76,   138,    18,    63,    79,    82,   -76,   -76,   -76,
     -76,    11,    60,    69,   -76,    16,    57,    91,   -76,   -76,
      87,   100,   -76,   -76,   -76,    35,   101,    78,    76,   -76,
     -76,    68,   -76,    11,    92,     0,   -76,   108,   -76,   -76,
      96,    16,    35,    57,    57,   -76,    16,   -76,    87,   115,
     124,   -76,   -76,   104,   -76,   -76,    75,   -76,   -76,    87,
     -76,    35,   106,   137,   101,   101,   101,   111,   129,    38,
       9,   130,   136,   143,    12,   -76,   -76,   -76,   -76,   -76,
     -76,   -76,   -76,   -76,   126,   -76,   -76,   -76,   -76,    57,
     -76,   -76,   102,     4,   -76,   -76,   -76,    96,    96,    23,
     -76,   142,   -76,   145,   101,   -76,    22,   101,   -76,    16,
     101,   -76,    11,   -76,   111,   -76,   101,   111,   111,   101,
     101,    16,   101,   111,   -76,   111,    87,    -4,   144,     5,
      75,   -76,    96,   128,   -76,   133,   139,    49,   128,    96,
      96,   -76,    96,   128,   128,    36,   -76,   -76,   -76,   -76,
     111,   111,   111,   111,   146,   -76,   140,   -76,   -76,   -76
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -76,   -76,   -76,   158,   -76,   -76,   -76,   -76,   -76,    26,
     -76,   -76,   -76,   -76,   -76,   -76,   -76,   -64,   105,   -76,
     -58,     7,   -76,     8,   -76,   -76,   -59,   -24,    97,   -40,
     135,   -48,   -76,    93,   -75,   -44,   -76,   -76,   -76,   -30,
      -2
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -91
static const yytype_int16 yytable[] =
{
       8,    37,    12,    61,   115,   103,    50,    94,    67,    64,
      65,   156,    63,    57,    49,     2,     2,   134,   112,    24,
     158,    28,    29,    17,    60,    58,     7,    37,    30,    58,
      31,    63,    37,    60,    32,    33,   102,    34,    35,   122,
      28,    55,   115,    49,   107,   108,   109,   117,   131,   164,
      60,    60,   114,    32,    33,   125,    34,    36,   135,   -90,
      10,    58,   -90,     2,     9,   141,   -90,   -90,   -90,    18,
     148,   138,   155,    53,    54,   153,    72,   154,   162,   163,
      49,    94,   123,   151,   137,    19,   -16,    20,    41,    25,
     139,    73,    44,    74,    75,    37,   142,    76,    26,   149,
     150,    43,   152,   167,   168,    47,    49,    37,    52,    77,
     102,    51,    78,    79,    80,    81,    36,    82,    56,   126,
     140,   127,   128,    59,    60,   129,   130,    69,   131,    70,
      60,   132,     1,   105,   -90,     2,    71,   133,   -90,   -90,
     -90,    13,   106,   113,   119,    14,    15,    16,   110,   111,
     120,    81,    36,    82,   121,   124,   114,   136,   161,   157,
     160,   169,    11,    68,   -50,   -51,   159,   165,   104,   166,
      48,     0,     0,   118
};

static const yytype_int16 yycheck[] =
{
       2,    25,     4,    51,    79,    69,    36,    66,    56,    53,
      54,    15,    52,    13,     5,     4,     4,    13,    77,    21,
      15,     5,     6,     5,    28,    25,    11,    51,    12,    25,
      14,    71,    56,    28,    18,    19,    66,    21,    22,    27,
       5,    43,   117,     5,    74,    75,    76,    38,    26,    13,
      28,    28,    14,    18,    19,    99,    21,    41,    35,     0,
       1,    25,     3,     4,     0,   124,     7,     8,     9,     6,
     128,   119,   136,     5,     6,   133,     1,   135,    29,    30,
       5,   140,    84,   131,   114,     6,    11,     5,    31,    29,
     120,    16,     5,    18,    19,   119,   126,    22,    29,   129,
     130,    10,   132,   162,   163,     5,     5,   131,    32,    34,
     140,    33,    37,    38,    39,    40,    41,    42,    26,    17,
     122,    19,    20,    15,    28,    23,    24,    12,    26,     5,
      28,    29,     1,    27,     3,     4,    32,    35,     7,     8,
       9,     3,     5,    14,    14,     7,     8,     9,    37,    38,
      14,    40,    41,    42,    11,    29,    14,    12,    25,    15,
      32,    15,     4,    58,    25,    25,   140,   160,    71,   161,
      35,    -1,    -1,    80
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,     4,    44,    45,    46,    83,    11,    83,     0,
       1,    46,    83,     3,     7,     8,     9,     5,     6,     6,
       5,    47,    50,    51,    83,    29,    29,    48,     5,     6,
      12,    14,    18,    19,    21,    22,    41,    70,    72,    73,
      74,    31,    78,    10,     5,    60,    61,     5,    73,     5,
      82,    33,    32,     5,     6,    83,    26,    13,    25,    15,
      28,    74,    71,    72,    78,    78,    49,    74,    61,    12,
       5,    32,     1,    16,    18,    19,    22,    34,    37,    38,
      39,    40,    42,    52,    53,    54,    55,    56,    57,    58,
      59,    62,    67,    68,    69,    70,    75,    76,    77,    79,
      80,    81,    82,    60,    71,    27,     5,    82,    82,    82,
      37,    38,    69,    14,    14,    77,    82,    38,    76,    14,
      14,    11,    27,    83,    29,    78,    17,    19,    20,    23,
      24,    26,    29,    35,    13,    35,    12,    82,    74,    82,
      83,    69,    82,    63,    64,    65,    66,    69,    63,    82,
      82,    74,    82,    63,    63,    60,    15,    15,    15,    52,
      32,    25,    29,    30,    13,    64,    66,    69,    69,    15
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 94 "parser.y"
    {
	       char * comment_str = (yyvsp[(2) - (2)]) ;
	       if (comment_str && strlen (comment_str) > 0 && keep_comments) {
		 xmlNodePtr comment_node = xmlNewComment ((xmlChar*)comment_str) ;
		 xmlAddChild (MetaGrammar, comment_node) ;
	       }
	     }
    break;

  case 3:
#line 102 "parser.y"
    {
             DBUGYACC(printf ("One Dcl\n") ;);
             }
    break;

  case 5:
#line 106 "parser.y"
    {printf ("\nLine number: %d\n",yylineno);}
    break;

  case 6:
#line 109 "parser.y"
    {
	       char * comment_str = (yyvsp[(1) - (3)]) ;
	       class_found += 1;
	       CurrentClass = xmlNewChild (MetaGrammar, NULL, (xmlChar*)"class", NULL) ;
	       xmlSetProp (CurrentClass, (xmlChar*)"name", (xmlChar*)(yyvsp[(3) - (3)])) ;
	       new_class_symb ((yyvsp[(3) - (3)]), 1, yylineno) ;
	       if (comment_str && strlen (comment_str) > 0 && keep_comments) {
		 xmlNodePtr comment_node = xmlNewComment ((xmlChar*)comment_str) ;
		 xmlAddChild (CurrentClass, comment_node) ;
	       }
	     }
    break;

  case 7:
#line 121 "parser.y"
    {
	       char * comment_str = (yyvsp[(5) - (5)]) ;
	       if (comment_str && strlen (comment_str) > 0 && keep_comments) {
		 xmlNodePtr comment_node = xmlNewComment ((xmlChar*)comment_str) ;
		 xmlAddChild (CurrentClass, comment_node) ;
	       }
	     }
    break;

  case 8:
#line 129 "parser.y"
    {
	       char * comment_str = (yyvsp[(8) - (8)]) ;
	       if (comment_str && strlen (comment_str) > 0 && keep_comments) {
		 xmlNodePtr comment_node = xmlNewComment ((xmlChar*)comment_str) ;
		 xmlAddChild (CurrentClass, comment_node) ;
	       }
	     }
    break;

  case 9:
#line 137 "parser.y"
    {
	       /* reinitialiser pour une autre classe */
	       CurrentClass = NULL ;
             }
    break;

  case 10:
#line 142 "parser.y"
    {
	       new_template_macro_symb ((yyvsp[(3) - (3)]), 1, yylineno) ;
             }
    break;

  case 11:
#line 146 "parser.y"
    {
	       char * comment_str = (yyvsp[(1) - (6)]) ;
	       xmlNodePtr templateNode = xmlNewNode (NULL, (xmlChar*)"vLib") ;
	       if (comment_str && strlen (comment_str) > 0 && keep_comments) {
		 xmlNodePtr comment_node = xmlNewComment ((xmlChar*)comment_str) ;
		 xmlAddChild (MetaGrammar, comment_node) ;
	       }
	       xmlSetProp (templateNode, (xmlChar*)"id", (xmlChar*)(yyvsp[(3) - (6)])) ;
	       xmlAddChild (templateNode, (xmlNodePtr)(yyvsp[(6) - (6)])) ;
	       xmlAddChild (MetaGrammar, templateNode) ;
             }
    break;

  case 12:
#line 158 "parser.y"
    {
	       new_path_macro_symb ((yyvsp[(3) - (3)]), 1, yylineno) ;
             }
    break;

  case 13:
#line 162 "parser.y"
    {
	       char * comment_str = (yyvsp[(1) - (6)]) ;
	       xmlNodePtr MacroNode = xmlNewNode (NULL, (xmlChar*)"path") ;
	       if (comment_str && strlen (comment_str) > 0 && keep_comments) {
		 xmlNodePtr comment_node = xmlNewComment ((xmlChar*)comment_str) ;
		 xmlAddChild (MetaGrammar, comment_node) ;
	       }
	       xmlSetProp (MacroNode, (xmlChar*)"id", (xmlChar*)(yyvsp[(3) - (6)])) ;
	       xmlAddChild (MacroNode, (xmlNodePtr)(yyvsp[(6) - (6)])) ;
	       xmlAddChild (MetaGrammar, MacroNode) ;
             }
    break;

  case 14:
#line 174 "parser.y"
    {
	       char * comment_str = (yyvsp[(1) - (3)]) ;
	       xmlNodePtr DisableNode = xmlNewNode (NULL, (xmlChar*)"disable") ;
	       if (comment_str && strlen (comment_str) > 0 && keep_comments) {
		 xmlNodePtr comment_node = xmlNewComment ((xmlChar*)comment_str) ;
		 xmlAddChild (MetaGrammar, comment_node) ;
	       }
	       xmlSetProp (DisableNode, (xmlChar*)"name", (xmlChar*)(yyvsp[(3) - (3)])) ;
	       xmlAddChild (MetaGrammar, DisableNode) ;
             }
    break;

  case 15:
#line 184 "parser.y"
    {printf ("\nLine number: %d\n",yylineno);}
    break;

  case 17:
#line 188 "parser.y"
    {
	       char * comment_str = (yyvsp[(2) - (2)]) ;
	       if (comment_str && strlen (comment_str) > 0 && keep_comments) {
		 xmlNodePtr property_node = (xmlNodePtr)(yyvsp[(1) - (2)]) ;
		 xmlNodePtr comment_node = xmlNewComment ((xmlChar*)comment_str) ;
		 DBUGYACC(printf ("Commentaire dans une propriete (1): %s comment_node=%o property_node=%o\n",
				  (xmlChar*)(yyvsp[(2) - (2)]), comment_node, property_node););
		 xmlAddNextSibling (property_node, comment_node) ;
	       }
	     }
    break;

  case 18:
#line 199 "parser.y"
    {
	       char * comment_str = (yyvsp[(3) - (4)]) ;
	       if (comment_str && strlen (comment_str) > 0 && keep_comments) {
		 xmlNodePtr property_node = (xmlNodePtr)(yyvsp[(1) - (4)]) ;
		 xmlNodePtr comment_node = xmlNewComment ((xmlChar*)comment_str) ;
		 DBUGYACC(printf ("Commentaire dans une propriete (liste): %s comment_node=%o property_node=%o Proplist=%o\n",
				  (xmlChar*)(yyvsp[(3) - (4)]), comment_node, property_node, (yyvsp[(4) - (4)])););
		 xmlAddNextSibling (property_node, comment_node) ;
	       }
	     }
    break;

  case 19:
#line 209 "parser.y"
    {printf ("\nLine number: %d\n",yylineno);}
    break;

  case 32:
#line 225 "parser.y"
    {
	       xmlNodePtr InheritNode = xmlNewChild (CurrentClass, NULL, (xmlChar*)"super", NULL) ;
	       DBUGYACC(printf ("Propriete Heritage: %s\n",(yyvsp[(2) - (2)])););
	       xmlSetProp (InheritNode, (xmlChar*)"name", (xmlChar*)(yyvsp[(2) - (2)])) ;
	       new_class_symb ((yyvsp[(2) - (2)]), 0, yylineno) ;
	       (yyval) = (xmlChar*) InheritNode ;
             }
    break;

  case 33:
#line 234 "parser.y"
    {
	       xmlNodePtr FatherNode = xmlNewChild (CurrentClass, NULL, (xmlChar*)"relation", NULL) ;
               DBUGYACC(printf ("Propriete Pere: %s %s\n",(yyvsp[(1) - (3)]),(yyvsp[(3) - (3)])););
	       xmlSetProp (FatherNode, (xmlChar*)"rel", (xmlChar*)"father") ;
	       xmlSetProp (FatherNode, (xmlChar*)"arg1", (xmlChar*)(yyvsp[(1) - (3)])) ;
	       xmlSetProp (FatherNode, (xmlChar*)"arg2", (xmlChar*)(yyvsp[(3) - (3)])) ;
	       (yyval) = (xmlChar*) FatherNode ;
             }
    break;

  case 34:
#line 244 "parser.y"
    {
	       xmlNodePtr AncestorNode = xmlNewChild (CurrentClass, NULL, (xmlChar*)"relation", NULL) ;
               DBUGYACC(printf ("Propriete Anctre: %s %s\n",(yyvsp[(1) - (3)]),(yyvsp[(3) - (3)])););
	       xmlSetProp (AncestorNode, (xmlChar*)"rel", (xmlChar*)"dominates") ;
	       xmlSetProp (AncestorNode, (xmlChar*)"arg1", (xmlChar*)(yyvsp[(1) - (3)])) ;
	       xmlSetProp (AncestorNode, (xmlChar*)"arg2", (xmlChar*)(yyvsp[(3) - (3)])) ;
	       (yyval) = (xmlChar*) AncestorNode ;
             }
    break;

  case 35:
#line 254 "parser.y"
    {
	       xmlNodePtr PrecNode = xmlNewChild (CurrentClass, NULL, (xmlChar*)"relation", NULL) ;
	       DBUGYACC(printf ("Propriete Prcdence: %s %s\n",(yyvsp[(1) - (3)]),(yyvsp[(3) - (3)])););
	       xmlSetProp (PrecNode, (xmlChar*)"rel", (xmlChar*)"precedes") ;
	       xmlSetProp (PrecNode, (xmlChar*)"arg1", (xmlChar*)(yyvsp[(1) - (3)])) ;
	       xmlSetProp (PrecNode, (xmlChar*)"arg2", (xmlChar*)(yyvsp[(3) - (3)])) ;
	       (yyval) = (xmlChar*) PrecNode ;
             }
    break;

  case 36:
#line 264 "parser.y"
    {
	       xmlNodePtr PrecNode = xmlNewChild (CurrentClass, NULL, (xmlChar*)"relation", NULL) ;
	       DBUGYACC(printf ("Propriete Equality: %s %s\n",(yyvsp[(1) - (3)]),(yyvsp[(3) - (3)])););
	       xmlSetProp (PrecNode, (xmlChar*)"rel", (xmlChar*)"equals") ;
	       xmlSetProp (PrecNode, (xmlChar*)"arg1", (xmlChar*)(yyvsp[(1) - (3)])) ;
	       xmlSetProp (PrecNode, (xmlChar*)"arg2", (xmlChar*)(yyvsp[(3) - (3)])) ;
	       (yyval) = (xmlChar*) PrecNode ;
             }
    break;

  case 37:
#line 276 "parser.y"
    {
	       xmlNodePtr DescNode = xmlNewChild (CurrentClass, NULL,
						  (xmlChar*)"description", NULL) ;
	       DBUGYACC(printf ("Propriete desc:%s %o\n",(yyvsp[(4) - (6)]),(yyvsp[(4) - (6)])););
	       xmlAddChild (DescNode, (xmlNodePtr) (yyvsp[(4) - (6)])) ;
	       (yyval) = (xmlChar*) DescNode ;
             }
    break;

  case 38:
#line 285 "parser.y"
    {
	       xmlNodePtr FSNode = xmlNewNode (NULL, (xmlChar*)"fs") ;
	       DBUGYACC(printf ("Features : liste vide %o\n", FSNode););
	       (yyval) = (char*) FSNode ;
             }
    break;

  case 39:
#line 291 "parser.y"
    {
	       xmlNodePtr FNode = (xmlNodePtr) (yyvsp[(1) - (1)]) ;
	       xmlNodePtr FSNode = xmlNewNode (NULL, (xmlChar*)"fs") ;
	       DBUGYACC(printf ("Features : F %o %o\n", (yyvsp[(1) - (1)]), FSNode););
	       xmlAddChild (FSNode, FNode) ;
	       (yyval) = (char*) FSNode ;
             }
    break;

  case 40:
#line 299 "parser.y"
    {
	       xmlNodePtr FNode = (xmlNodePtr) (yyvsp[(3) - (3)]) ;
	       xmlNodePtr FSNode = (xmlNodePtr) (yyvsp[(1) - (3)]) ;
	       DBUGYACC(printf ("Features : F FS %o %o %o\n", (yyvsp[(3) - (3)]), (yyvsp[(2) - (3)]), FSNode););
	       xmlAddChild (FSNode, FNode) ;
	       (yyval) = (char*) FSNode ;
             }
    break;

  case 41:
#line 308 "parser.y"
    {
	       xmlNodePtr FNode = xmlNewNode (NULL, (xmlChar*)"f") ;
	       DBUGYACC(printf ("Feature %s %o %o\n", (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]), FNode););
	       xmlSetProp (FNode, (xmlChar*)"name", (xmlChar*)(yyvsp[(1) - (3)])) ;
	       xmlAddChild (FNode, (xmlNodePtr)(yyvsp[(3) - (3)])) ;
	       (yyval) = (char*) FNode ;
             }
    break;

  case 42:
#line 318 "parser.y"
    { 
               xmlNodePtr GuardNode = (xmlNodePtr) (yyvsp[(3) - (3)]);
               xmlSetProp (GuardNode, (xmlChar*)"rel", (xmlChar *) "+");
               xmlSetProp (GuardNode, (xmlChar*)"name", (xmlChar *) (yyvsp[(1) - (3)]));
               xmlAddChild (CurrentClass, GuardNode) ;
	       DBUGYACC(printf("Guard: GuardNode=%o %s\n",GuardNode, (yyvsp[(1) - (3)])););
	       (yyval) = (char*) GuardNode ;
             }
    break;

  case 43:
#line 327 "parser.y"
    { 
               xmlNodePtr GuardNode = (xmlNodePtr) (yyvsp[(4) - (4)]);
               xmlSetProp (GuardNode, (xmlChar*)"rel", (xmlChar *) "-");
               xmlSetProp (GuardNode, (xmlChar*)"name", (xmlChar *) (yyvsp[(2) - (4)]));
               xmlAddChild (CurrentClass, GuardNode) ;
	       DBUGYACC(printf("Guard: GuardNode=%o ~%s\n",GuardNode,(yyvsp[(2) - (4)])););
	       (yyval) = (char*) GuardNode ;
             }
    break;

  case 44:
#line 336 "parser.y"
    {
               xmlNodePtr GuardNode = (xmlNodePtr) (yyvsp[(3) - (3)]);
               xmlNodePtr FailNode = xmlNewNode(NULL, (xmlChar*)"guard");
               xmlSetProp (GuardNode, (xmlChar*)"rel", (xmlChar *) "+");
               xmlSetProp (GuardNode, (xmlChar*)"name", (xmlChar *) (yyvsp[(1) - (3)]));
               xmlAddChild (CurrentClass, GuardNode) ;
               xmlSetProp (FailNode, (xmlChar*)"rel", (xmlChar *) "-");
               xmlSetProp (FailNode, (xmlChar*)"name", (xmlChar *) (yyvsp[(1) - (3)]));
               xmlAddChild (CurrentClass, FailNode) ;
	       DBUGYACC(printf("Guard: GuardNode=%o %s\n",GuardNode, (yyvsp[(1) - (3)])););
	       (yyval) = (char*) GuardNode ;
             }
    break;

  case 45:
#line 349 "parser.y"
    {
               xmlNodePtr GuardNode = (xmlNodePtr) (yyvsp[(3) - (3)]);
               xmlNodePtr FailNode = xmlNewNode(NULL, (xmlChar*)"guard");
               xmlSetProp (GuardNode, (xmlChar*)"rel", (xmlChar *) "++");
               xmlSetProp (GuardNode, (xmlChar*)"name", (xmlChar *) (yyvsp[(1) - (3)]));
               xmlAddChild (CurrentClass, GuardNode) ;
               xmlSetProp (FailNode, (xmlChar*)"rel", (xmlChar *) "-");
               xmlSetProp (FailNode, (xmlChar*)"name", (xmlChar *) (yyvsp[(1) - (3)]));
               xmlAddChild (CurrentClass, FailNode) ;
	       DBUGYACC(printf("Guard: GuardNode=%o %s\n",GuardNode, (yyvsp[(1) - (3)])););
	       (yyval) = (char*) GuardNode ;
             }
    break;

  case 46:
#line 364 "parser.y"
    { 
                 xmlNodePtr GuardNode = xmlNewNode (NULL, (xmlChar*)"guard");
                 xmlAddChild (GuardNode,(xmlNodePtr)(yyvsp[(1) - (1)]));
		 DBUGYACC(printf("EqAlt: GuardNode=%o\n",GuardNode););
                 (yyval) = (char *)GuardNode;
             }
    break;

  case 47:
#line 371 "parser.y"
    {    xmlNodePtr GuardNode = (xmlNodePtr) (yyvsp[(1) - (3)]);
	          xmlAddChild (GuardNode,(xmlNodePtr) (yyvsp[(3) - (3)]));
		  DBUGYACC(printf("EqAlt: GuardNode=%o\n",GuardNode););
		  (yyval) = (yyvsp[(1) - (3)]);
	     }
    break;

  case 48:
#line 377 "parser.y"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 49:
#line 378 "parser.y"
    {
         xmlNodePtr SeqGuardNode = (xmlNodePtr) (yyvsp[(1) - (3)]);
         xmlAddChild (SeqGuardNode,(xmlNodePtr) (yyvsp[(3) - (3)]));
	 DBUGYACC(printf("EqSeq: SeqGuardNode=%o\n",SeqGuardNode););
         (yyval) = (yyvsp[(1) - (3)]);
     }
    break;

  case 50:
#line 385 "parser.y"
    {
       xmlNodePtr SeqGuardNode = xmlNewNode (NULL, (xmlChar*)"and");
       xmlAddChild (SeqGuardNode,(xmlNodePtr)(yyvsp[(1) - (1)]));
       DBUGYACC(printf ("EqSeq1 (1): SeqGuardNode=%o %o\n", SeqGuardNode));
       (yyval) = (char *)SeqGuardNode;
              }
    break;

  case 51:
#line 392 "parser.y"
    {
                  xmlNodePtr SeqGuardNode = (xmlNodePtr) (yyvsp[(1) - (3)]);
	          xmlAddChild (SeqGuardNode,(xmlNodePtr) (yyvsp[(3) - (3)]));
		  DBUGYACC(printf ("EqSeq1: SeqGuardNode=%o %o\n", SeqGuardNode, (yyvsp[(3) - (3)])));
		  (yyval) = (yyvsp[(1) - (3)]);
              }
    break;

  case 52:
#line 400 "parser.y"
    { 
               xmlNodePtr EqNode = xmlNewNode (NULL, (xmlChar*)"equation");
               xmlAddChild (EqNode, (xmlNodePtr) (yyvsp[(1) - (3)]));
               xmlAddChild (EqNode, (xmlNodePtr) (yyvsp[(3) - (3)]));
               (yyval) = (char *)EqNode;
	       DBUGYACC(printf ("EqElem: EqNode=%o\n", EqNode));
             }
    break;

  case 53:
#line 408 "parser.y"
    { 
               xmlNodePtr EqNode = xmlNewNode (NULL, (xmlChar*)"equation");
               xmlSetProp (EqNode, (xmlChar*)"default", (xmlChar *) "+");
               xmlAddChild (EqNode, (xmlNodePtr) (yyvsp[(1) - (3)]));
               xmlAddChild (EqNode, (xmlNodePtr) (yyvsp[(3) - (3)]));
               (yyval) = (char *)EqNode;
	       DBUGYACC(printf ("EqElem: EqNode=%o\n", EqNode));
             }
    break;

  case 54:
#line 419 "parser.y"
    { 
               xmlNodePtr AtomicNode = xmlNewNode (NULL, (xmlChar*)"atomic");
               xmlAddChild (AtomicNode, (xmlNodePtr) (yyvsp[(2) - (2)]));
               xmlAddChild (CurrentClass, AtomicNode) ;
               (yyval) = (char *)AtomicNode;
             }
    break;

  case 55:
#line 427 "parser.y"
    {
	       xmlNodePtr EquationNode = xmlNewNode (NULL, (xmlChar*)"equation") ;
	       xmlNodePtr Root1 = (xmlNodePtr)(yyvsp[(1) - (3)]) ;
	       xmlNodePtr Root2 = (xmlNodePtr)(yyvsp[(3) - (3)]) ;
	       xmlAddChild (EquationNode, Root1) ;
	       xmlAddChild (EquationNode, Root2) ;
	       xmlAddChild (CurrentClass, EquationNode) ;
	       DBUGYACC(printf ("Propriete Equation : Equation_node=%o Root1=%o Root2=%o\n", EquationNode, (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])););
               (yyval) = (char *)EquationNode ;
             }
    break;

  case 56:
#line 439 "parser.y"
    {
	       xmlNodePtr RootNode = (xmlNodePtr)(yyvsp[(1) - (2)]) ;
	       xmlAddChild (RootNode, (xmlNodePtr)(yyvsp[(2) - (2)])) ;
	       DBUGYACC(printf ("EqTerm: RootNode:%o Path:%o\n",RootNode,(yyvsp[(2) - (2)])););
	       (yyval) = (char*) RootNode ;
             }
    break;

  case 57:
#line 446 "parser.y"
    {
	       xmlNodePtr Node = xmlNewNode (NULL, (xmlChar*)"value") ;
	       xmlAddChild (Node, (xmlNodePtr)(yyvsp[(3) - (4)])) ;
	       DBUGYACC(printf ("EqTerm: Node:%o Value:%o\n",Node,(yyvsp[(3) - (4)])););
	       (yyval) = (char*) Node ;
             }
    break;

  case 58:
#line 454 "parser.y"
    {
	       xmlNodePtr VarNode = xmlNewNode (NULL, (xmlChar*)"var") ;
	       xmlSetProp (VarNode, (xmlChar*)"name", (xmlChar*)(yyvsp[(2) - (2)])) ;
	       (yyval) = (char*) VarNode ;
           }
    break;

  case 59:
#line 461 "parser.y"
    {
                 xmlNodePtr AltNode = xmlNewNode (NULL, (xmlChar*)"vAlt") ;
                 xmlAddChild (AltNode, (xmlNodePtr) (yyvsp[(1) - (1)])) ;
                 (yyval) = (char*) AltNode ;
	     }
    break;

  case 60:
#line 467 "parser.y"
    {
	       xmlNodePtr AltNode = (xmlNodePtr)(yyvsp[(3) - (3)]) ;
	       xmlNodePtr FirstAltNode = AltNode->xmlChildrenNode ;
	       xmlAddPrevSibling (FirstAltNode, (xmlNodePtr)(yyvsp[(1) - (3)])) ;
	       (yyval) = (char*) AltNode ;
	     }
    break;

  case 61:
#line 474 "parser.y"
    {
	       xmlNodePtr VarNode = xmlNewNode (NULL, (xmlChar*)"symbol") ;
	       xmlSetProp (VarNode, (xmlChar*)"value", (xmlChar*)(yyvsp[(1) - (1)])) ;
	       (yyval) = (char*) VarNode ;
	     }
    break;

  case 62:
#line 481 "parser.y"
    {
	       xmlNodePtr VarNode = xmlNewNode (NULL, (xmlChar*)"symbol") ;
	       xmlSetProp (VarNode, (xmlChar*)"value", (xmlChar*)"*") ;
	       (yyval) = (char*) VarNode ;
	     }
    break;

  case 63:
#line 487 "parser.y"
    {
	       (yyval) = (char*) xmlNewNode (NULL, (xmlChar*)"plus") ;
	     }
    break;

  case 64:
#line 491 "parser.y"
    {
	       (yyval) = (char*) xmlNewNode (NULL, (xmlChar*)"minus") ;
	     }
    break;

  case 65:
#line 495 "parser.y"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 66:
#line 497 "parser.y"
    {
	       xmlNodePtr AltNode = (xmlNodePtr)(yyvsp[(3) - (3)]) ;
	       xmlNodePtr FirstAltNode = AltNode->xmlChildrenNode ;
	       xmlAddPrevSibling (FirstAltNode, (xmlNodePtr) (yyvsp[(1) - (3)])) ;
	       (yyval) = (char*) AltNode ;
	     }
    break;

  case 67:
#line 504 "parser.y"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 68:
#line 506 "parser.y"
    {
	       xmlNodePtr NotNode = xmlNewNode (NULL, (xmlChar*)"not") ;
               xmlAddChild(NotNode, (xmlNodePtr)(yyvsp[(2) - (2)]));
	       (yyval) = (char*) NotNode ;
	     }
    break;

  case 69:
#line 512 "parser.y"
    {
	       (yyval) = (yyvsp[(1) - (1)]);
	     }
    break;

  case 70:
#line 516 "parser.y"
    {
                 xmlNodePtr VarNode = (xmlNodePtr) (yyvsp[(1) - (3)]);
                 xmlAddChild (VarNode, (xmlNodePtr)(yyvsp[(3) - (3)])) ;
                 (yyval) = (char*) VarNode ;
	     }
    break;

  case 71:
#line 522 "parser.y"
    {
	       xmlNodePtr FNode = xmlNewNode (NULL, (xmlChar*)"fs") ;
	       xmlSetProp (FNode, (xmlChar*)"idref", (xmlChar*)(yyvsp[(1) - (1)])) ;
	       (yyval) = (char*) FNode ;
             }
    break;

  case 72:
#line 528 "parser.y"
    {
	       (yyval) = (char*) (yyvsp[(2) - (3)]) ;
             }
    break;

  case 73:
#line 532 "parser.y"
    {
                 xmlSetProp ((yyvsp[(5) - (6)]), (xmlChar *) "type", (xmlChar *) (yyvsp[(2) - (6)]));
                 (yyval) = (char*) (yyvsp[(5) - (6)]) ;
             }
    break;

  case 75:
#line 540 "parser.y"
    {
	      xmlNodePtr Node = (xmlNodePtr) (yyvsp[(2) - (2)]) ;
	      xmlSetProp (Node, (xmlChar*)"optional", (xmlChar*)"yes") ;
	      (yyval) = (char*) Node ;
	    }
    break;

  case 76:
#line 547 "parser.y"
    {
	      xmlNodePtr Node = (xmlNodePtr) (yyvsp[(1) - (1)]) ;
	      xmlSetProp (Node, (xmlChar*)"virtual", (xmlChar*)"yes") ;
	      (yyval) = (char*) Node ;
	    }
    break;

  case 77:
#line 553 "parser.y"
    {
	      xmlNodePtr Node = (xmlNodePtr) (yyvsp[(2) - (2)]) ;
	      xmlSetProp (Node, (xmlChar*)"virtual", (xmlChar*)"no") ;
	      (yyval) = (char *) Node ;
	    }
    break;

  case 78:
#line 560 "parser.y"
    {
	       xmlNodePtr Node = xmlNewNode (NULL, (xmlChar*)"node") ;
	       DBUGYACC (printf ("Node %s\n",(yyvsp[(1) - (3)])););
	       xmlSetProp (Node, (xmlChar*)"name", (xmlChar*)(yyvsp[(1) - (3)])) ;
//               xmlSetProp (Node, (xmlChar*)"virtual", (xmlChar*)"yes") ;
	       xmlAddChild (Node, (xmlNodePtr)(yyvsp[(3) - (3)])) ;
	       xmlAddChild (CurrentClass, Node) ;
               (yyval)= (char *) Node;
           }
    break;

  case 79:
#line 571 "parser.y"
    {
	       xmlNodePtr PathNode = NULL ;
	       (yyval) = (char*) PathNode ;
	     }
    break;

  case 80:
#line 576 "parser.y"
    {
	       xmlNodePtr PathNode = xmlNewNode (NULL, (xmlChar*)"f") ;
	       xmlSetProp (PathNode, (xmlChar*)"name", (xmlChar*)(yyvsp[(2) - (3)])) ;
	       if ((yyvsp[(3) - (3)]) != NULL) {
		 xmlAddChild (PathNode, (xmlNodePtr)(yyvsp[(3) - (3)])) ;
	       }
	       (yyval) = (char*) PathNode ;
	     }
    break;

  case 81:
#line 585 "parser.y"
    {
	       xmlNodePtr PathNode = xmlNewNode (NULL, (xmlChar*)"path") ;
	       xmlSetProp (PathNode, (xmlChar*)"idref", (xmlChar*)(yyvsp[(2) - (3)])) ;
	       if ((yyvsp[(3) - (3)]) != NULL) {
		 xmlAddChild (PathNode, (xmlNodePtr)(yyvsp[(3) - (3)])) ;
	       }
	       new_path_macro_symb ((yyvsp[(2) - (3)]), 0, yylineno) ;
	       (yyval) = (char*) PathNode ;
	     }
    break;

  case 82:
#line 596 "parser.y"
    {
	       xmlNodePtr Node = xmlNewNode (NULL, (xmlChar*)"description") ;
	       (yyval) = (char*) Node ;
	     }
    break;

  case 83:
#line 601 "parser.y"
    {
	       xmlNodePtr Node = xmlNewNode (NULL, (xmlChar*)"father") ;
	       xmlSetProp (Node, (xmlChar*)"name", (xmlChar*)(yyvsp[(3) - (4)])) ;
	       (yyval) = (char*) Node ;
	     }
    break;

  case 84:
#line 607 "parser.y"
    {
	       xmlNodePtr Node = xmlNewNode (NULL, (xmlChar*)"node") ;
	       xmlSetProp (Node, (xmlChar*)"name", (xmlChar*)(yyvsp[(3) - (4)])) ;
	       (yyval) = (char*) Node ;
	     }
    break;

  case 85:
#line 613 "parser.y"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 86:
#line 616 "parser.y"
    {
	       xmlNodePtr Node = xmlNewChild (CurrentClass, NULL, (xmlChar*)"needs", NULL) ;
	       DBUGYACC(printf ("Propriete Needs:%s\n",(yyvsp[(1) - (2)])););
	       xmlSetProp (Node, (xmlChar*)"name", (xmlChar*)(yyvsp[(2) - (2)])) ;
	       (yyval) = (char*) Node ;
             }
    break;

  case 87:
#line 624 "parser.y"
    {
	       xmlNodePtr Node = xmlNewChild (CurrentClass, NULL, (xmlChar*)"provides", NULL) ;
	       DBUGYACC(printf ("Propriete Provides:%s\n",(yyvsp[(1) - (2)])););
	       xmlSetProp (Node, (xmlChar*)"name", (xmlChar*)(yyvsp[(2) - (2)])) ;
	       (yyval) = (char*) Node ;
             }
    break;

  case 88:
#line 632 "parser.y"
    {
	       (yyval) = (char*) (yyvsp[(1) - (1)]) ;
             }
    break;

  case 89:
#line 636 "parser.y"
    {
	       char * str1 = (char*) (yyvsp[(1) - (3)]) ;
	       char * str2 = (char*) (yyvsp[(3) - (3)]) ;
	       char * newstr = (char*) calloc (strlen(str1) + 2 + strlen(str2),
					       sizeof (char)) ;
	       sprintf (newstr, "%s:%s", str1, str2) ;
	       (yyval) = newstr ;
             }
    break;

  case 90:
#line 645 "parser.y"
    { (yyval) = NULL ; }
    break;

  case 91:
#line 647 "parser.y"
    {
	       char * str1 = (yyvsp[(1) - (2)]); char * str2 = (yyvsp[(2) - (2)]) ;
	       DBUGYACC(printf ("Doc:\t%s\n", (yyvsp[(1) - (2)])););
	       (yyval) = cp_str (str1,str2) ;
             }
    break;


/* Line 1267 of yacc.c.  */
#line 2361 "parser.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



